diff -Nraup linux-2.6.14_mm1/arch/ia64/kernel/ivt.S linux-2.6.14_mm1_bsp/arch/ia64/kernel/ivt.S
--- linux-2.6.14_mm1/arch/ia64/kernel/ivt.S	2005-11-09 19:08:51.000000000 +0800
+++ linux-2.6.14_mm1_bsp/arch/ia64/kernel/ivt.S	2005-11-24 01:04:03.000000000 +0800
@@ -1042,10 +1042,24 @@ END(dispatch_illegal_op_fault)
 	DBG_FAULT(17)
 	FAULT(17)
 
+ENTRY(preserve_scratch_area)
+	alloc r14=ar.pfs,0,0,2,0
+	adds r12=-16,r12
+	;;
+	br.call.sptk.many rp=ia64_bad_break	// avoid WAW on CFM
+	;;
+	movl r15=ia64_leave_kernel
+	adds r12=16,r12
+	;;
+	mov rp=r15
+	;;
+	br.ret.sptk.many rp
+END(preserve_scratch_area)
+
 ENTRY(non_syscall)
 	mov ar.rsc=r27			// restore ar.rsc before SAVE_MIN_WITH_COVER
 	;;
-	SAVE_MIN_WITH_COVER
+	SAVE_MIN_WITH_COVER_BSP
 
 	// There is no particular reason for this code to be here, other than that
 	// there happens to be space here that would go unused otherwise.  If this
@@ -1062,12 +1076,10 @@ ENTRY(non_syscall)
 	srlz.i				// guarantee that interruption collection is on
 	;;
 (p15)	ssm psr.i			// restore psr.i
-	movl r15=ia64_leave_kernel
 	;;
 	SAVE_REST
-	mov rp=r15
 	;;
-	br.call.sptk.many b6=ia64_bad_break	// avoid WAW on CFM and ignore return addr
+	br.call.sptk.many b6=preserve_scratch_area	// avoid WAW on CFM and ignore return addr
 END(non_syscall)
 
 	.org ia64_ivt+0x4800
diff -Nraup linux-2.6.14_mm1/arch/ia64/kernel/minstate.h linux-2.6.14_mm1_bsp/arch/ia64/kernel/minstate.h
--- linux-2.6.14_mm1/arch/ia64/kernel/minstate.h	2005-11-09 19:08:51.000000000 +0800
+++ linux-2.6.14_mm1_bsp/arch/ia64/kernel/minstate.h	2005-11-23 22:45:49.000000000 +0800
@@ -196,3 +196,21 @@
 #define SAVE_MIN_WITH_COVER	DO_SAVE_MIN(cover, mov r30=cr.ifs,)
 #define SAVE_MIN_WITH_COVER_R19	DO_SAVE_MIN(cover, mov r30=cr.ifs, mov r15=r19)
 #define SAVE_MIN		DO_SAVE_MIN(     , mov r30=r0, )
+
+#ifdef	CONFIG_KPROBES
+/*
+ * Here we save ar.bsp (after cover) to the scratch area below pt_regs for kprobe purpose.
+ * Kprobe uses it to locate the function parameters on RBS in kprobe handler.
+ *
+ */
+#define	EXTRA_SAVE_BSP				\
+	mov r23=ar.bsp				\
+	;;					\
+	st8 [r12]=r23
+
+#define	SAVE_MIN_WITH_COVER_BSP	DO_SAVE_MIN(cover, mov r30=cr.ifs, EXTRA_SAVE_BSP)
+
+#else
+#define	SAVE_MIN_WITH_COVER_BSP	SAVE_MIN_WITH_COVER
+#endif
+
